#!/usr/bin/env node

var path = require('path')
var cli = require(path.join(__dirname, '../dist/cli', 'index.js'))
var argv = process.argv.slice(2)

const argvObj = {}
let lastKey = ''
while (argv.length) {
  const item = argv.shift().trim()
  if (item.startsWith('--')) {
    const key = item.slice(2)
    if (!(key in argvObj)) {
      argvObj[key] = null
      lastKey = key
    }
    continue
  }

  // 数组
  if (argvObj[lastKey]) {
    if (Array.isArray(argvObj[lastKey])) {
      argvObj[lastKey].push(item)
    } else {
      argvObj[lastKey] = [argvObj[lastKey]]
      argvObj[lastKey].push(item)
    }
  } else {
    argvObj[lastKey] = item
  }
}

var ret = cli.main(argvObj.tags || [])
if (typeof ret === 'number') {
  process.exit(ret)
}