"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var path = require('path');
var fs = require('fs');
var spawnSync = require('child_process').spawnSync;
var protobufjsName = 'protobufjs';
var defaultTags = ['db', 'dbpost', 'dbpre', 'rpc'];
function foundGlobalProtobufjsPath() {
    return __awaiter(this, void 0, void 0, function () {
        var target, res;
        return __generator(this, function (_a) {
            target = '';
            res = spawnSync('yarn', ['global', 'dir'], { encoding: 'utf-8' });
            if (!res.stderr) {
                target = res.stdout.replace(/\n$/g, '');
                target = path.resolve(target, 'node_modules/', protobufjsName);
                if (fs.existsSync(target)) {
                    return [2 /*return*/, target];
                }
            }
            // get npm node_modules
            res = spawnSync('npm', ['root', '-g'], { encoding: 'utf-8' });
            if (!res.stderr) {
                target = res.stdout.replace(/\n$/g, '');
                target = path.resolve(target, protobufjsName);
                if (fs.existsSync(target)) {
                    return [2 /*return*/, target];
                }
            }
            return [2 /*return*/, ''];
        });
    });
}
exports.main = function (tags) { return __awaiter(void 0, void 0, void 0, function () {
    var targetModule, keepTags, workPath, fileName, targetFile, dataStr, lines, startReg, endReg, startIndex, endIndex, i, line, j, source, hasAlternateCommentMode, spaceStr, res, fileName, targetFile, dataStr, reg, newLine, fileName, targetFile, tsdJsdoc, tsdJsdocObj, fileName, targetFile, dataStr, lines, startReg, endReg, startIndex, endIndex, i, line, j, spaceStr_1, res_1, source_1, addTags_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                targetModule = path.resolve(__dirname, '../../../', protobufjsName);
                if (!!fs.existsSync(targetModule)) return [3 /*break*/, 2];
                return [4 /*yield*/, foundGlobalProtobufjsPath()
                    // protobufjs模块未找到
                ];
            case 1:
                // 查找全局的yarn,npm包地址
                targetModule = _a.sent();
                // protobufjs模块未找到
                if (!targetModule) {
                    console.log('can not found %s, please sure install it?', protobufjsName);
                    return [2 /*return*/, 1];
                }
                _a.label = 2;
            case 2:
                keepTags = __spread(new Set(__spread(defaultTags, tags)));
                workPath = path.resolve(targetModule, 'cli');
                if (fs.existsSync(workPath)) {
                    fileName = 'pbjs.js';
                    targetFile = path.resolve(workPath, fileName);
                    dataStr = fs.readFileSync(targetFile).toString('utf-8');
                    try {
                        lines = dataStr.split(/\r?\n|\r/g);
                        startReg = /var parseOptions = {/;
                        endReg = /};?/;
                        startIndex = -1;
                        endIndex = -1;
                        for (i = 0; i < lines.length; i++) {
                            line = lines[i];
                            if (startReg.test(line)) {
                                startIndex = i + 1;
                                for (j = i + 1; j < lines.length; j++) {
                                    if (endReg.test(lines[j])) {
                                        endIndex = j;
                                        break;
                                    }
                                }
                                break;
                            }
                        }
                        if (!(startIndex === -1 || endIndex === -1)) {
                            source = lines.slice(startIndex, endIndex);
                            hasAlternateCommentMode = source.some(function (line) { return line.includes('alternateCommentMode'); });
                            if (!hasAlternateCommentMode) {
                                spaceStr = ' '.repeat(8);
                                res = lines.slice(0, startIndex).join('\n') + '\n';
                                res += spaceStr + '"alternateCommentMode": argv["alternate-comment-mode"] || false,\n';
                                res += lines.slice(startIndex, lines.length - 1).join('\n') + '\n';
                                fs.writeFileSync(targetFile, res);
                                console.log('set alternateCommentMode is true');
                            }
                        }
                    }
                    catch (e) { }
                }
                // static.js#132行，替换多级包名处理 push((config.es6 ? "const" : "var") + " " + escapeName(ns.name) + " = {};");
                workPath = path.resolve(targetModule, 'cli/targets');
                if (fs.existsSync(workPath)) {
                    fileName = 'static.js';
                    targetFile = path.resolve(workPath, fileName);
                    dataStr = fs.readFileSync(targetFile).toString('utf-8');
                    reg = /push\(\(config\.es6\s?\?\s?["']const["'].*escapeName\(ns\.name\).*=\s?{};["']\)/g;
                    if (reg.test(dataStr)) {
                        newLine = 'push((config.es6 ? "const" : "var") + " " + escapeName(ns.name) + " = $root." + escapeName(ns.name) + " || {};");';
                        fs.writeFileSync(targetFile, dataStr.replace(reg, newLine));
                        console.log('replace static.js escapeName');
                    }
                }
                // 修改protobufjs下jsDoc插件json配置，允许不识别的tag
                workPath = path.resolve(targetModule, 'cli/lib');
                if (fs.existsSync(workPath)) {
                    fileName = 'tsd-jsdoc.json';
                    targetFile = path.resolve(workPath, fileName);
                    tsdJsdoc = fs.readFileSync(targetFile).toString('utf-8');
                    try {
                        tsdJsdocObj = JSON.parse(tsdJsdoc);
                        if (tsdJsdocObj.tags && !tsdJsdocObj.tags.allowUnknownTags) {
                            tsdJsdocObj.tags.allowUnknownTags = true;
                            fs.writeFileSync(targetFile, JSON.stringify(tsdJsdocObj, null, 2));
                            console.log('set allowUnknownTags is true');
                        }
                    }
                    catch (e) { }
                }
                // 修改protobufjs下jsDoc插件publish.js, 保留需要的tag注释
                workPath = path.resolve(targetModule, 'cli/lib/tsd-jsdoc');
                if (fs.existsSync(workPath)) {
                    fileName = 'publish.js';
                    targetFile = path.resolve(workPath, fileName);
                    dataStr = fs.readFileSync(targetFile).toString('utf-8');
                    try {
                        lines = dataStr.split(/\r?\n|\r/g);
                        startReg = /var keepTags = \[/;
                        endReg = /\];?/;
                        startIndex = -1;
                        endIndex = -1;
                        for (i = 0; i < lines.length; i++) {
                            line = lines[i];
                            if (startReg.test(line)) {
                                startIndex = i + 1;
                                for (j = i + 1; j < lines.length; j++) {
                                    if (endReg.test(lines[j])) {
                                        endIndex = j;
                                        break;
                                    }
                                }
                                break;
                            }
                        }
                        if (!(startIndex === -1 || endIndex === -1)) {
                            spaceStr_1 = ' '.repeat(4);
                            res_1 = lines.slice(0, startIndex).join('\n') + '\n';
                            source_1 = lines.slice(startIndex, endIndex);
                            addTags_1 = [];
                            keepTags.forEach(function (tag) {
                                var hasTag = source_1.some(function (line) { return line.includes(tag); });
                                if (!hasTag) {
                                    res_1 += spaceStr_1 + ("\"" + tag + "\",\n");
                                    addTags_1.push(tag);
                                }
                            });
                            res_1 += lines.slice(startIndex, lines.length - 1).join('\n') + '\n';
                            fs.writeFileSync(targetFile, res_1);
                            addTags_1.length && console.log('add custom jsdoc tag', addTags_1);
                        }
                    }
                    catch (e) { }
                }
                return [2 /*return*/];
        }
    });
}); };
